﻿@model eCommerce.UI.ViewModels.ShoppingCartViewModel
@using eCommerce.Services.Model.Enums
@using eCommerce.Services.Utils
@{
    ViewBag.Title = "Terminá tu compra";
}

<style>

    .swal2-popup {
        font-size: 1.5rem;
    }
</style>

<div class="checkout checkout--summary">
    <div class="checkout__header">
        <div class="content__container">

            <h2 class="checkout__header-title">Finalizá tu pedido</h2>

            <div class="checkout__header-action -tablet">
                <span class="checkout__header-action-text js-toggle-summary">Ver resumen</span>
            </div>
        </div>
    </div>

    @using (Html.BeginForm("Checkout", "ShoppingCart", FormMethod.Post, new { @id = "CheckoutForm" }))
    {
        <input type="hidden" name="DeliveryMethodId" id="DeliveryMethodId" />
        <input type="hidden" name="PaymentMethodId" id="PaymentMethodId" />
        <input type="hidden" name="AndreaniShippingCost" class="hidAndreaniCost" />

        <div class="checkout__body">
            <div class="content__container checkout__container">

                <div class="checkout__steps-container">
                    @Html.Partial("Checkout/BillingInfo/BillingInfo", Model.ExtraInfo)

                    @Html.Partial("Checkout/PaymentMethod/PaymentMethod", Model)

                    @Html.Partial("Checkout/CreditCard/CreditCardData", Model)

                    @Html.Partial("Checkout/DeliveryMethod/DeliveryMethod", Model)

                    @Html.Partial("Checkout/ExtraInfo/ExtraInfo", Model.ExtraInfo)


                </div>

                <div class="checkout__summary js-summary">

                    @Html.Partial("Checkout/Summary/Summary", Model)

                </div>

                <div class="checkout__finish">
                    <span class="checkout__total">Total: <span class="js-total-mobile">@((Model.TotalOrderDetails - (Model.TotalOrderDetails * Model.Discount / 100) + Model.ShippingCost).ToString("c2"))</span></span>

                    <button type="submit" class="button checkout__button js-end-order">Finalizar Pedido  </button>
                </div>
            </div>
        </div>

    }

</div>

@section Scripts{
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>
    <script src="https://live.decidir.com/static/v2.5/decidir.js"></script>
    <script>

        $(document).ready(function () {

            initializeForm();

            fbq('track', 'InitiateCheckout');

            $('.js-security-code').removeAttr('autocomplete');
            $('.js-holder-name').removeAttr('autocomplete');

            var discountElem = $('.js-discount').find('.pricing-item__total').val(1);

            var discountText = discountElem.text().split('$')[1];

            if (discountText.indexOf('.') == -1) {
                var discount = discountText;
            }
            else {
                var discount = discountText.replace('.', ',').replace(',', '');
            }
            $('#Discount').val(discount);

            $('.js-credit-card-number').mask('0000-0000-0000-0000');
            $('.js-security-code').mask('0000');
            $('.js-expiration-month').mask('00');
            $('.js-expiration-year').mask('00');

            var currentSubtotal =  $('.js-subtotal').find('.pricing-item__total').text();
            var currentDiscount =  $('.js-discount').find('.pricing-item__total').text();

            var subtotalValue = currentSubtotal.replace("$", "").replace(".", "").replace(",", ".")
            var discountValue = currentDiscount.replace("$", "").replace(".", "").replace(",", ".")

            $('.js-subtotal').find('.pricing-item__total').text(formatCurrency(subtotalValue));
            $('.js-discount').find('.pricing-item__total').text(formatCurrency(discountValue));

            SumShippingCostAndDiscount();
        });

        function initializeForm()
        {
            var pathArray = window.location.pathname.split('/');
            var storeRoot = "/" + pathArray[1];

            var $form = $('#CheckoutForm');
            $form.attr('action', "/checkout");
        }

        //funcion de invocacion con sdk
        function ValidateDecidir(deliverymethodid, paymentmethodid)
        {
            //event.preventDefault();
            var form = document.getElementById('formDecidir');
            if (validFormDecidir(form))
            {
                //var publicApiKey = "e9cdb99fff374b5f91da4480c8dca741";
                //var urlSandbox = "https://developers.decidir.com/api/v2";
                //var decidir = new Decidir(urlSandbox);

                //Verified - Fibra Humana
                var publicApiKey = "18809269472249b8981f617f744f2e0a";
                var urlProd = "https://live.decidir.com/api/v2";
                var decidir = new Decidir(urlProd);

                decidir.setPublishableKey(publicApiKey);
                decidir.setTimeout(5000);//timeout de 5 segundos
                decidir.createToken(form, function (status, response)
                {
                    if (status != 200 && status != 201)
                    {
                        console.log(response);
                        //Manejo de error: Ver Respuesta de Error

                        toastr.warning("Hubo un error al validar los datos de su tarjeta");
                        //...codigo...
                    } else {
                        var token = response.id;
                        var bin = response.bin;

                        var optionSelected = $('.bankinterest-select option:selected');
                        var installments = optionSelected.data('installments');
                        $('.checkout__body').append('<input type="hidden" name="decidir-token" value=' + token + ' />');
                        $('.checkout__body').append('<input type="hidden" name="decidir-bin" value=' + bin + ' />');
                        $('.checkout__body').append('<input type="hidden" name="decidir-installments" value=' + installments + ' />');
                        //Manejo de respuesta donde response = {token: "99ab0740-4ef9-4b38-bdf9-c4c963459b22"}
                        //..codigo...
                        //$('.js-end-order').prop('disabled', false);
                        //ScrollToElement($('.js-end-order'));
                        $("#DeliveryMethodId").val(deliverymethodid);
                        $("#PaymentMethodId").val(paymentmethodid);
                        $("#CheckoutForm").submit();
                    }
                });
                //formulario y callback
            }
            else {
                toastr.warning("Ingrese todos los campos correctamente.");
            }
        }

        $('.bankinterest-select').change(function() {

            if($(this).val() != null)
            {
                var optionSelected = $('.bankinterest-select option:selected');

                var surcharge = optionSelected.data('surcharge');

                var surchargeElem = $('.js-surcharge');
                surchargeElemValue = surchargeElem.find('.pricing-item__total');
                var toggle = false;
                if (parseFloat(surcharge) > 0)
                {
                    toggle = true;

                    var subtotalText = $('.js-subtotal').find('.pricing-item__total').text();
                    var discountText = $('.js-discount').find('.pricing-item__total').text();
                    var shippingCostText = $('.js-shipping-cost').find('.pricing-item__total').text();

                    var subtotalValue = parseFloat(subtotalText.replace("$","").replace(",", ""));

                    var discountValue = 0;
                    if(discountText)
                        discountValue = parseFloat(discountText.replace("$","").replace(",", ""));

                    var shippingCostValue = 0;
                    if(shippingCostText)
                        shippingCostValue = parseFloat(shippingCostText.replace("$","").replace(",", ""));

                    var currentTotal = subtotalValue - discountValue + shippingCostValue;
                    var surchargeTotal = currentTotal * surcharge / 100;

                    //var surchargeTotalText = surchargeTotal.toString();
                    //var surchargeTotalText = ValueToStringWithoutDot(surchargeTotal.toString().replace('.',''));
                    //surchargeElemValue.val(surchargeTotal);

                    $('#Surcharge').val(surchargeTotal)
                    surchargeElemValue.text(formatCurrency(surchargeTotal));
                }
                else
                {
                    $('#Surcharge').val(0)
                    surchargeElemValue.text(formatCurrency(0));
                }

                SumShippingCostAndDiscount();

                surchargeElem.toggleClass('hide', !toggle);
            }
        });

        function ValueToStringWithoutDot(amount){

            return parseFloat(amount.toString().replace('.',''));

        }

        $('.bank-select').change(function() {
            debugger;
            var currentBankId = $('.bank-select option:selected').val();

            $.ajax({
                type: "GET",
                cache: false,
                url:  "/ShoppingCart/GetInterestsForSelectedBank",
                data: { BankId: currentBankId },
                success: function (data)
                {
                    var $interests = data.Interests;

                    var total = parseFloat($('.pricing-item__total').html().replace('$', '').replace(',', ''));

                        if ($interests != null)
                        {
                            if ($interests.length > 0) {
                                var selectToAppend = $('.bankinterest-select');
                                $('.bankinterest-list').removeClass('hide');

                                selectToAppend.empty();

                                $($interests).each(function(i, item)
                                {
                                    if(item.MinAmount <= total || item.MinAmount == null) {
                                        selectToAppend.append('<option value="' +  item.Id + '" data-installments="' + item.Installments + '" data-surcharge="' + item.Surcharge + '">' + item.Name + '</option>');
                                    }
                                });

                                $('.bankinterest-select').change();
                            }
                            else{
                                toastr.warning("No hay promociones disponibles para el banco seleccionado.");
                            }
                        }
                        else{
                            toastr.warning("Se produjo un error al obtener las promociones del banco seleccionado.");
                        }



                }
            });



        });

        function ScrollToElement($element) {
            $('html, body').animate({
                scrollTop: $element.offset().top - 100
            }, 800);
        }

        function validFormDecidir(form)
        {
            return true;
            var isValid = true;
            $(form).find('.step-form__group-input').each(function ()
            {
                if ($(this).data('decidir') == "card_number" && $(this).val().length != 19) {
                    isValid = false;
                } else if ($(this).data('decidir') == "security_code" && $(this).val().length != 3) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_expiration_month" && $(this).val().length != 2) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_expiration_year" && $(this).val().length != 2) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_holder_name" && $(this).val().length == 0) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_holder_doc_number" && $(this).val().length == 0) {
                    isValid = false;
                }
            });
            return isValid;
        }

        $('.js-step-radio').change(function ()
        {
            debugger;
            var $step = $(this).closest('.checkout__step');
            $step.addClass('checkout__step--filled');
            if ($(this).hasClass('js-delivery-method'))
            {
                SetDiscountText(0);

                SumShippingCostAndDiscount();

                var showLocales = $(this).data("showlocales");

                var Excluded = $(this).data("excluded");
                if (Excluded.length > 1) {
                    Excluded = Excluded.split(",");
                }else {
                    Excluded = [Excluded];
                }

                for (var i = 0; i < Excluded.length; i++) {
                    $(".PaymentMethod").removeClass("hidden");
                    $("#PaymentMethodList_" + Excluded[i]).addClass("hidden");
                }


                $('.js-general-info').addClass('hidden');

                debugger;
                var isTransport = $(this).data('transport');
                if (isTransport == "True") {
                    $('.js-receipt').parent().removeClass("hidden");
                    $('.js-shipping-cost').css('display', 'flex');
                    $('#ShippingCost').val(1);

                    $('.js-address-info').toggleClass('hidden', !isTransport);

                    var cost = $(this).data("cost");
                    if (cost.length > 0) {
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency(cost));
                        $('.js-shipping-cost').css('display', 'flex');
                        $('#ShippingCost').val(cost)
                        SumShippingCostAndDiscount();
                    }else {
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency("0"));
                        $('#ShippingCost').val(0)
                        SumShippingCostAndDiscount();
                    }

                }else {
                    var cost = $(this).data("cost");
                    $('.js-receipt').parent().addClass("hidden");
                    if (cost.length > 0) {
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency(cost));
                        $('.js-shipping-cost').css('display', 'flex');
                        $('#ShippingCost').val(cost)
                        SumShippingCostAndDiscount();
                    }else {
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency("0"));
                        $('#ShippingCost').val(0)
                        SumShippingCostAndDiscount();
                    }

                    if(showLocales == "True")
                        $(".js-stores").removeClass("hidden");
                    else
                        $(".js-stores").addClass("hidden");

                    $('.js-address-info').addClass('hidden');

                    var RequireData = $(this).data("requireddata");

                    if (RequireData == "True") {

                        if ($(this).data("isprovince") == "False") {
                            $("#province-Select").css("display","none");
                        }else{
                            $("#province-Select").css("display","block");

                        }
                        $('.js-general-info').removeClass('hidden');
                    }
                }


                var isOca = $(this).data('type') == "oca" || $(this).data('type') == "ocap";
                var type = $(this).data('type') == "oca" ? "@((int)OcaSendType.PAS)" : "@((int)OcaSendType.PAP)";

                var isAndreani = $(this).data('type') == "andreanid" || $(this).data('type') == "andreanis";
                var typeAndreani = $(this).data('type') == "andreanid" ? "@((int)AndreaniSendType.Domicilio)" : "@((int)AndreaniSendType.Sucursal)";

                $('.js-oca-info').toggleClass('hidden', !isOca);
                $('.js-ocas-info').toggleClass('hidden', !(type == "@((int)OcaSendType.PAS)"));
                $('.js-ocap-info').toggleClass('hidden', !(type == "@((int)OcaSendType.PAP)"));

                $('.js-andreani-info').toggleClass('hidden', !isAndreani);
                $('.js-andreanis-info').toggleClass('hidden', !(typeAndreani == "@((int)AndreaniSendType.Sucursal)"));
                $('.js-andreanid-info').toggleClass('hidden', !(typeAndreani == "@((int)AndreaniSendType.Domicilio)"));

                $('.js-end-order').attr('disabled', isAndreani);

                var isStore = $(this).data('type') == 'store';
                if (isStore) {
                    $('.js-end-order').attr('disabled', false);
                }
                var isRetail = "@(Model.Customer.UserType == (int)UserTypeEnum.Minorista)";

                if (isRetail == "True") {
                    $('.js-stores-wholesale').addClass('hidden');
                    $('.js-stores-retail').removeClass('hidden');
                }
                else {
                    $('.js-stores-retail').addClass('hidden');
                    $('.js-stores-wholesale').removeClass('hidden');
                }

                if ($(this).val() == "13" && $('input:radio[name=PaymentMethod]:checked').val() == "9") {
                    SetDiscountText(5);

                    SumShippingCostAndDiscount();
                }

            }

            if ($(this).hasClass('js-payment-method'))
            {
                SetDiscountText(0);

                SumShippingCostAndDiscount();
                var elem = $(this);

                $('.js-payment-method').removeClass('js-payment-method-selected');
                elem.addClass('js-payment-method-selected');
                var isDecidir = $(this).data('decidir');

                //$('.checkout__step[data-credit-card="true"]').toggleClass('hidden', !isDecidir);

                if (!isDecidir) {
                    $('.js-surcharge').find('.pricing-item__total').text("$0.00");
                    $('.js-surcharge').addClass('hide');
                } else {
                    $('.bankinterest-select').change();
                }

                if ($(this).data('qr'))
                {
                    ShowFibraQR();
                }

                if ($(this).data('transfer'))
                {
                    ShowFibraBankInfo();
                }

                if ($(this).val() == "9" && $('input:radio[name=ShippingMethod]:checked').val() == "13") {
                    SetDiscountText(5);

                    SumShippingCostAndDiscount();
                }

                //CheckCurrentPromotions();
            }

            if (isDecidir) {
                $('.bankinterest-select').change();
            }

            var $nextStep = $step.next('.checkout__step');
            if ($nextStep.length > 0)
                ScrollToElement($nextStep);

        });

        $('.js-get-andreani-sucursales').click(function (e) {
            e.preventDefault();
            var cp = $('.js-andreani-cp').val();
            if (cp == '')
                return toastr.warning('Ingrese el código postal.');

            var dni = $('.js-andreani-dni').val();
            if (dni == '')
                return toastr.warning('Ingrese el DNI.');

            $('.ajax-loader').show();
            $.ajax({
                type: "POST",
                cache: false,
                url: "/ShoppingCart/GetAndreaniSucursales",
                data: { cp: cp },
                complete: function () { $('.ajax-loader').hide(); },
                success: function (data) {
                    if (data.Error == null) {
                        var $select = $('.js-andreani-sucursales');
                        $select.empty();
                        $.each(data.Sucursales, function (i, item) {
                            $select.append('<option value="' + item.Value + '">' + item.Text + '</option>');
                        });
                        $("#infoAndreani").fadeIn("300");
                        //$("#btnAvanzar").prop("disabled", false);
                        //$("#btnAvanzar").removeClass("disabled");
                    }
                    else {
                        toastr.warning(data.Error);
                    }
                }
            });
        });

        $('.js-store-avanzar').click(function () {
            $('.js-end-order').attr('disabled', false);
        });

        $('.js-andreani-cotizar').click(function (e) {
            e.preventDefault();
            var cp = $('.js-andreani-cp').val();
            var sucursal = $('.js-andreani-sucursal').val();
            $.ajax({
                type: "GET",
                cache: false,
                url: '/ShoppingCart/CotizarAndreaniSucursal',
                data: { cp: cp, sucursal: sucursal },
                success: function (data) {
                    if (data.Tarifa != null) {

                        $('.js-shipping-cost').css('display', 'flex');
                        $('#ShippingCost').val(1);
                        if (data.Tarifa == "0") {
                            $('.js-shipping-cost .pricing-item__total').text("(Bonificado) " + formatCurrency(data.Tarifa));
                        }
                        else {
                            $('.js-shipping-cost .pricing-item__total').text(formatCurrency(data.Tarifa));
                        }

                        $('.hidAndreaniCost').val(data.Tarifa);
                        $('.js-end-order').attr('disabled', false);
                        SumShippingCostAndDiscount();
                    }
                    else {
                        toastr.error(data.Error);
                    }
                }
            });

        });

        $('.js-calcular-costo-domicilio').click(function (e) {
            e.preventDefault();
            var cp = $('.js-andreanid-cp').val();
            if (cp == '')
                return toastr.warning('Ingrese el código postal.');

            var address = $('.js-andreanid-address').val();
            if (address == '')
                return toastr.warning('Ingrese la calle.');

            var addressProvince = $('.js-andreanid-province').val();
            if (addressProvince == '')
                return toastr.warning('Seleccione una provincia.');


            var addressNumber = $('.js-andreanid-addressNumber').val();
            if (addressNumber == '')
                return toastr.warning('Ingrese la altura.');

            var addressCity = $('.js-andreanid-city').val();
            if (addressCity == '')
                return toastr.warning('Ingrese la ciudad.');

            var addressProvince = $('.js-andreanid-dni').val();
            if (addressProvince == '')
                return toastr.warning('Ingrese el DNI.');

            $('.ajax-loader').show();
            $.ajax({
                type: "POST",
                cache: false,
                url: "/ShoppingCart/CotizarAndreaniDomicilio",
                data: { cp: cp },
                complete: function () { $('.ajax-loader').hide(); },
                success: function (data) {
                    if (data.Error == null) {
                        //$("#ShippingCost").val(data.Tarifa);
                        if (data.Tarifa == "0") {
                            $('.js-shipping-cost .pricing-item__total').text("(Bonificado) " + formatCurrency(data.Tarifa));
                        }
                        else {
                            $('.js-shipping-cost .pricing-item__total').text(formatCurrency(data.Tarifa));
                        }
                        $('.hidAndreaniCost').val(data.Tarifa);

                        $('.js-shipping-cost').css('display', 'flex');
                        SumShippingCostAndDiscount();
                        $('.js-end-order').attr('disabled', false);
                    }
                    else {
                        toastr.warning(data.Error);
                    }
                }
            });
        });

        //$('.js-andreanid-avanzar').click(function () {
        //    var tarifa = $('.js-andreanid-cost').val();
        //    //$(".shipment-cost").text(tarifa).formatCurrency();
        //    //$(".shipment-cost").closest('li').css('display', 'block');
        //    $('.js-shipping-cost').css('display', 'flex');
        //    $('#ShippingCost').val(1);

        //    //shippingCost = $('.js-shipping-cost').find('.pricing-item__total').text();
        //    $('.js-shipping-cost .pricing-item__total').text(formatCurrency(tarifa.split('$')[1]));
        //    $('.hidAndreaniCost').val(tarifa.replace('(Bonificado)', '').replace('$', ''));
        //    SumShippingCostAndDiscount();
        //    $('.js-end-order').attr('disabled', false);
        //    //$("#btnAvanzar").prop("disabled", false);
        //    //$("#btnAvanzar").removeClass("disabled");
        //});

        $('.js-toggle-cart').click(function () {
            var $cart = $(this).closest('.checkout__summary').find('.js-toggable');
            var $toggle = $(this).find('.icon-toggle');

            $cart.toggleClass('cart-summary__body--shown');
            $toggle.toggleClass('icon--toggle');
        });

        $('.js-toggle-summary').click(function () {
            $('.js-summary').toggleClass('checkout__summary--open');
        });

        /*function SumShippingCostAndDiscount()
        {
            var shippingCost = 0;

            var totalElem = $('.js-total').find('.pricing-item__total');
            var discountElem = $('.js-discount').find('.pricing-item__total');

            var totalText = totalElem.text().split('$')[1];
            var total;
            if(totalText.toString().indexOf('.') != -1)
                total = parseFloat(totalText.replace('.', '').replace(',', '.'));
            else
                total = parseFloat(totalText.replace(',', '.'));

            var discountText = discountElem.text().split('$')[1];
            var discount;
            if(discountText.toString().indexOf('.') != -1)
                discount = parseFloat(discountText.replace('.', '').replace(',', '.'));
            else
                discount = parseFloat(discountText.replace(',', '.'));

            shippingCost = $('.js-shipping-cost').find('.pricing-item__total').text().split('$')[1];
            surcharge = $('.js-surcharge').find('.pricing-item__total').text().split('$')[1];
            var surchargeValue = surcharge.replace(',', '');

            var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];
            var subtotal;
            if(subtotalText.toString().indexOf('.') != -1)
                subtotal = parseFloat(subtotalText.replace('.', '').replace(',', '.'));
            else
                subtotal = parseFloat(subtotalText.replace(',', '.'));

            var newTotal = parseFloat(subtotal) - parseFloat(discount) + parseFloat(shippingCost);

            if (ifDecidir()) {
                newTotal += parseFloat(surchargeValue);
            }

            totalElem.val(newTotal);
            var formattedTotal = formatCurrency(newTotal);
            totalElem.text(formattedTotal);
            $('.js-total-mobile').text(formattedTotal);

            /*if ($('.js-shipping-cost').css('display') == "flex")
            {
                shippingCost = $('.js-shipping-cost').find('.pricing-item__total').text().split('$')[1];

                var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];

                var subtotal;
                if (subtotalText.indexOf(',') != -1)
                {
                    subtotal = parseFloat(subtotalText.replace('.', '').replace(',', '.'));
                }
                else {
                    subtotal = parseFloat(subtotalText.replace(',', '.'));
                }

                var newTotal = parseFloat(subtotal) - parseFloat(discount) + parseFloat(shippingCost);

                if ($('.js-iva').length > 0) {
                    var ivaAmount = parseFloat($('.js-iva').data('amount'));
                    newTotal += ivaAmount;
                }

                totalElem.val(newTotal);
                var formattedTotal = formatCurrency(newTotal);
                totalElem.text(formattedTotal);
                $('.js-total-mobile').text(formattedTotal);
            }
            else
            {
                var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];

                if (subtotalText.indexOf(',') != -1) {
                    var subtotal = parseFloat(subtotalText.replace(".","").replace(",","."));
                }
                else {
                    var subtotal = parseFloat(subtotalText.replace(',', '.'));
                }

                var newTotal = parseFloat(subtotal) - parseFloat(discount);

                if ($('.js-iva').length > 0) {
                    var ivaAmount = parseFloat($('.js-iva').data('amount'));
                    newTotal += ivaAmount;
                }

                totalElem.val(newTotal);
                var formattedTotal = formatCurrency(newTotal);
                totalElem.text(formattedTotal);
                $('.js-total-mobile').text(formattedTotal);

            }*/
        //}

        function SumShippingCostAndDiscount()
        {
            debugger;
            var shippingCost = 0;
            var surcharge = 0;

            var totalElem = $('.js-total').find('.pricing-item__total');
            var discountElem = $('.js-discount').find('.pricing-item__total');

            var totalText = totalElem.text().split('$')[1];
            var discountText = discountElem.text().split('$')[1];

           if (discountText.indexOf(',') == -1) {
                var discount = discountText;
            }
            else {
                var discount = discountText.replace(',', '');
            }

            shippingCost = $('.js-shipping-cost').find('.pricing-item__total').text().split('$')[1].replace(',','');
            surcharge = $('.js-surcharge').find('.pricing-item__total').text().split('$')[1];
            var surchargeValue = surcharge.replace(',', '');

            var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];

            var subtotal = subtotalText.replace(',', '');

            var newTotal = parseFloat(subtotal) - parseFloat(discount) + parseFloat(shippingCost);

            if (ifDecidir()) {
                newTotal += parseFloat(surchargeValue);
            }

            totalElem.val(newTotal);
            var formattedTotal = formatCurrency(newTotal);
            totalElem.text(formattedTotal);
            $('.js-total-mobile').text(formattedTotal);

        }

        function formatCurrency(total) {
            return '$' + parseFloat(total, 10).toFixed(2).replace(/(\d)(?=(\d{3})+\.)/g, "$1,").toString();
        }

        $('.js-end-order').click(function (event) {
            debugger;
            event.preventDefault();


            //prevent double click.
            $(this).attr('disabled', true);
            //buttonAnimation(this);

            var valid = false;
            var paymentMethodId = "";
            var deliveryMethodId = "";




            $('.js-payment-method').each(function () {
                if ($(this).prop('checked')) {
                    paymentMethodId = $(this).val();
                }
            });

            $('.js-delivery-method').each(function () {
                if ($(this).prop('checked')) {
                    deliveryMethodId = $(this).val();
                }
            });

            if (paymentMethodId != "" && deliveryMethodId != "") {
                valid = true;
            } else {
                if (paymentMethodId == "") {
                    toastr.warning("La forma de pago es requerida.");
                }

                if (deliveryMethodId == "") {
                    toastr.warning("La forma de entrega es requerida.");
                }
            }

            $selected = $('.js-step-radio:checked');
            if ($selected.data('transport') == 'True') {

                if ($('.js-shipment-company').val() == "") {
                    valid = false;
                    $('.js-shipment-company').css("outline", "1px solid red");
                    toastr.warning("La empresa de transporte es requerida.");
                }
                else {
                    $('.js-shipment-company').css("outline", "none");
                }

                if ($('.js-shipment-address').val() == "") {
                    valid = false;
                    $('.js-shipment-address').css("outline", "1px solid red");
                    toastr.warning("La dirección de entrega es requerida.");
                }
                else {
                    $('.js-shipment-address').css("outline", "none");
                }

                if ($('.js-ciudad').val() == "") {
                    valid = false;
                    $('.js-ciudad').css("border", "1px solid red");
                    toastr.warning("La ciudad es requerida.");
                }

                if ($('.js-zipcode').val() == "") {
                    valid = false;
                    $('.js-zipcode').css("border", "1px solid red");
                    toastr.warning("El código postal es requerido.");
                }
            } else if ($selected.data('type') == 'oca') {
                if ($('.js-oca-sucursales').val() == null) {
                    valid = false;
                    $('.js-oca-sucursales').css("outline", "1px solid red");
                    toastr.warning("La sucursal es requerida.");
                }
                else
                    $('.js-oca-sucursales').css("outline", "none");
            } else if ($selected.data('type') == 'ocap') {

                if ($('#ShippingCost').val() != '1') {
                    valid = false;
                    toastr.warning("El costo de envío no ha sido calculado.");
                }
                else
                    $('.js-oca-cost').css("outline", "none");

                var fields = $('.js-ocap-info').find('input, select, textarea');
                fields.each(function (i, e) {
                    var mandatory = $(e).data('mandatory');
                    if (mandatory) {
                        if ($(e).val().length == 0) {
                            valid = false;
                            $(e).css("outline", "1px solid red");
                        } else {
                            $(e).css("outline", "none");
                        }
                    }
                });
            }

            @*if (deliveryMethodId == '@((int)DeliveryMethodEnum.RetiraEnCentroDeEntrega)') {
                if ($('.js-dni').val() == "") {
                    valid = false;
                    $('.js-dni').css("border", "1px solid red");
                    toastr.warning("El DNI es requerido.");
                }
            }*@

            if ($('.js-dni').val() == "") {
                valid = false;
                $('.js-dni').css("border", "1px solid red");
                toastr.warning("El DNI es requerido.");
            }


            $('.js-delivery-method').each(function () {
                if ($(this).prop('checked')) {
                    if ($(this).data('transport') == "True") {
                        //deliveryMethodId = $(this).val();
                        if ($('.js-receipt').val() == "") {
                            valid = false;
                            $('.js-receipt').css("border", "1px solid red");
                            toastr.warning("El monto es requerido.");
                        }
                    }
                }

            });

            var decidirPaymentMethodId = @((int)PaymentMethodEnum.Decidir);
            if (paymentMethodId == decidirPaymentMethodId && paymentMethodId != "" && deliveryMethodId != "" && valid)
            {
                ValidateDecidir(deliveryMethodId, paymentMethodId);
                return false;
            }

            if ($('.js-phone-number').val() == "") {
                valid = false;
                $('.js-phone-number').css("border", "1px solid red");
                toastr.warning("El teléfono es requerido.");
            }
            else {
                $('.js-phone-number').css("border", "1px solid #8f8f8f");
            }

            $("#DeliveryMethodId").val(deliveryMethodId);
            $("#PaymentMethodId").val(paymentMethodId);

            if (valid) {
                $("#CheckoutForm").submit();

            }
            else
            {
                $(this).attr('disabled', false);
            }

        });

        $('.js-oca-calculate-cost').click(function ()
        {
            var zipCode = $('.js-oca-zipcode').val();
            $('.js-oca-cost-info').addClass('hidden');
            if (zipCode.length <= 0) toastr.warning('El código postal es necesario para calcular el costo.');

            var $selected = $('.js-step-radio:checked');
            var type = $selected.data('type') == 'oca' ? "@((int)OcaSendType.PAS)" : "@((int)OcaSendType.PAP)";

            if (type == "@((int)OcaSendType.PAS)")
                GetCenters(zipCode);

            $.ajax({
                type: "GET",
                cache: false,
                url:  "/ShoppingCart/GetOcaCost",
                data: { zipCode: zipCode, sendType: type },
                success: function (data)
                {
                    if (data.Error.length == 0)
                    {
                        $('.js-oca-cost').text(data.Cost);
                        $('.js-shipping-cost').css('display', 'flex');
                        $('#ShippingCost').val(1);
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency(data.Cost.split("$")[1].replace('.','')));
                        debugger;

                        SumShippingCostAndDiscount();
                        $('.js-oca-cost-info').removeClass('hidden');
                    } else
                    {
                        toastr.warning(data.Error);
                        data.Cost = "$ 0,00";
                        $('.js-oca-cost').text(data.Cost);
                        $('.js-shipping-cost').css('display', 'flex');
                        $('#ShippingCost').val(1);
                        $('.js-shipping-cost .pricing-item__total').text(formatCurrency(data.Cost));
                        $('.js-oca-cost-info').addClass('hidden');
                    }
                }
            });
        });

        function GetCenters(zipCode) {
            $.ajax({
                type: "GET",
                cache: false,
                url:  "/ShoppingCart/GetOcaCenters",
                data: { zipCode: zipCode },
                success: function (data) {
                    if (data.Error.length == 0) {
                        var $centers = $('.js-oca-sucursales');
                        $centers.empty();

                        $.each(data.Centers, function (i, item) {
                            var option =
                                $("<option></option>")
                                .val(item.Id)
                                .text(item.Nombre);

                            $centers.append(option);
                        });

                    } else {
                        toastr.warning(data.Error)
                    }
                }
            });

        }

        function ShowFibraQR()
        {
            $(".js-fibra-qr").click();
        }

        function ShowFibraBankInfo()
        {
            $(".js-fibra-banks-info").click();
        }

        function CheckCurrentPromotions()
        {
            var IsIndex = false;

            $.ajax({
                type: "GET",
                cache: false,
                url: "/ShoppingCart/CheckCurrentPromotions",
                data: { isIndex: IsIndex, paymentMethodId: $(".js-payment-method:checked").val() },
                success: function (data)
                {
                    if(data.Model && data.Model.OrderDiscount != null && data.Model.OrderDiscount > 0)
                    {
                        //guardar el porcentaje en un hidden
                        $("#Discount").val(data.Model.OrderDiscount);

                        //Mostrar el descuento.
                        SetDiscountText(data.Model.OrderDiscount);

                        //Aplicar descuentos
                        SumShippingCostAndDiscount();
                    }
                    else{

                        SetDiscountText(0);

                        SumShippingCostAndDiscount();
                    }
                }
            });
        }

        function SetDiscountText(discount)
        {
            debugger;
            if(discount > 0)
            {
                var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];
                var subTotal = parseFloat(subtotalText.replace(",", ""))

                var discountValue = subTotal * parseFloat(discount) / 100;
                $("#Discount").val(discount);
                $('.js-discount').toggleClass("hide", false);
                $('.js-discount').css("display", "flex");
                $('.js-discount .pricing-item__title').text('Descuento: ' + discount + '%');
                $('.js-discount .pricing-item__total').text(formatCurrency(discountValue));
            }
            else
            {

                $('.js-discount .pricing-item__total').text(formatCurrency(discount));
                $('.js-discount').css("display", "none");
                $('.js-discount').toggleClass("hide", true);
            }
        }

        function ifDecidir(){
            return $('.js-payment-method-selected').data('decidir');
        }

        $('#SameInfo').change(function () {

            if ($(this).prop("checked")) {
                //Checked
                //User info.
                var fullName = $('.js-name').val();
                var dni = $('.js-dni-hidden').val();

                $('.js-name-complete').val(fullName);
                $('.js-dni-complete').val(dni);

                return;
            }
            else {
                // not checked
                $('.js-name-complete').val("");
                $('.js-dni-complete').val("");
            }

        });


    </script>

}